@import url('https://fonts.googleapis.com/css2?family=Noto+Sans+KR:wght@100..900&family=Noto+Sans+TC:wght@100..900&family=Noto+Sans:ital,wght@0,100..900;1,100..900&display=swap');
@import url('https://fonts.googleapis.com/css2?family=Noto+Serif+KR:wght@200..900&family=Noto+Serif+TC:wght@200..900&family=Noto+Serif:ital,wght@0,100..900;1,100..900&display=swap');
@import url('https://fonts.googleapis.com/css2?family=Noto+Serif+Display:ital,wght@0,100..900;1,100..900&display=swap');

:root {
  --bg-rgb: 230, 230, 230;
  --text-rgb: 70, 0, 0;
  --cinnabar-rgb: 204, 0, 0;

  --tumblr-color: #36465D;
  --bluesky-color: #1185FE;
  --youtube-color: #FF0000;
  --sketchfab-color: #1CAAD9;

  --kofi-color: #FF6433;
  --github-color: #181717;

  --line-width: 0.2em;
  --stroke-width: 0.2em;
  --outline-width: 0.2rem;
  --element-padding: 0.5em;
  --fade-buffer-padding: 3rem;

  --hover-time: 0.25s;
  --dogear-percent: 0%;
}

a {
  color: currentColor;
}

/* Blocking */

body {
  margin: 0%;
  padding: 0%;
  min-width: 100dvw;
  min-height: 100dvh;

  display: flex;
  flex-direction: column;

  background-color: rgb(var(--bg-rgb));
  color: rgb(var(--text-rgb));

  font-family: "Noto Serif", "Noto Serif KR", "Noto Serif TC", serif;
  font-size: 1rem;
  line-height: 1.5;
}

header {
  padding: 1rem;
}

main {
  padding: 1rem;
  overflow-x: auto;

  flex-grow: 1;

  display: flex;
  justify-content: space-evenly;
  align-items: center;
}

footer {
  padding: 1rem;

  display: flex;
  justify-content: flex-end;
  align-items: flex-end;
}

/* Elements */

.seal-print {
  width: 6rem;
  height: 6rem;
}

.seal-print a {
  display: block;
  width: 100%;
  height: 100%;
}

.seal-shadow {
  background-image: url("../images/3lm-seal-shadow.svg");
  background-size: cover;
  background-position: center;
  background-repeat: no-repeat;
}

.square {
  position: relative;
  width: 75vmin;
  height: 75vmin;
  min-width: 20rem;
  min-height: 20rem;
  max-width: 36rem;
  max-height: 36rem;
}

.square-back {
  position: absolute;
  width: 100%;
  height: 100%;

  display: flex;
  justify-content: flex-end;
  align-items: flex-end;

  mask-image: linear-gradient(315deg, transparent 50%, white 50%), linear-gradient(#000 0 0);
  mask-composite: exclude;
  mask-size: 200% 200%;
  mask-repeat: no-repeat;
  mask-mode: alpha;
  mask-position: 0% 0%;

  transition: all 0.5s;
}

.square-front {
  position: absolute;
  width: 100%;
  height: 100%;

  mask-image: linear-gradient(315deg, transparent 50%, white 50%);
  mask-size: 200% 200%;
  mask-repeat: no-repeat;
  mask-mode: alpha;
  mask-position: 0% 0%;

  transition: all 0.5s;

  pointer-events: none;
}

.body-text-wrapper {
  mask-image: linear-gradient(white, white), linear-gradient(transparent, white);
  mask-composite: subtract;
  mask-size: 100% 100%, 100% var(--fade-buffer-padding);
  mask-repeat: no-repeat, no-repeat;
  mask-position: top, bottom;

  overflow: scroll;
  outline-offset: calc(-1*var(--outline-width));

  animation: fadein-left .5s ease-out 0.2s both;

  pointer-events: auto;
}

.fade-buffer {
  height: var(--fade-buffer-padding);
}

.nav-wrapper {
  display: flex;
}

.nav-container {
  padding: var(--outline-width);
}

.nav-container a {
  text-decoration: none;
}

.nav-wall {
  border-right: var(--stroke-width) solid rgb(var(--text-rgb));

  transform: scaleY(0);
  transform-origin: top;
  animation: grow-top 0.5s ease 0.2s both;
}

.nav-button {
  font-family: "Noto Sans", sans-serif;
  font-weight: 300;
  font-size: 1.5rem;
  text-align: right;
  
  pointer-events: auto;
}

.socials-container {
  display: flex;
  gap: 1em;
  padding: var(--outline-width);
}

.socials-button {
  width: 2rem;
  height: 2rem;

  border: var(--line-width) solid currentColor;
  border-radius: calc(2*var(--line-width));
  
  display: flex;
  align-items: center;
  justify-content: center;

  transition: var(--hover-time);

  pointer-events: auto;
}

.socials-button svg {
  width: 1.5rem;
  height: 1.5rem;
}

.dogear-container {
  display: inline-block;
  position: absolute;
  right: 0;
  bottom: 0;
  width: 0;
  height: 0;
  transition: all 0.5s;
}

.footer-links-container {
  display: flex;
  gap: 1rem;
  justify-content: flex-end;
  align-items: flex-end;
}

.footer-button {
  width: 2rem;
  height: 2rem;

  border: var(--line-width) solid currentColor;
  border-radius: calc(2*var(--line-width));

  display: flex;
  align-items: center;
  justify-content: center;

  transition: var(--hover-time);
}

.footer-button svg {
  width: 1.5rem;
  height: 1.5rem;
}

/* Layout Tools */

.stripped {
  list-style-type: none;
  margin: 0;
  padding: 0;
}

.flexrow {
  display: flex;
  flex-flow: row;
  justify-content: space-between;
}

/* Hide scrollbar for Chrome, Safari and Opera */
.hide-scrollbar::-webkit-scrollbar {
  display: none;
}

/* Hide scrollbar for IE, Edge and Firefox */
.hide-scrollbar {
  -ms-overflow-style: none;  /* IE and Edge */
  scrollbar-width: none;  /* Firefox */
}

/* Branded Behavior */

.tumblr:hover {
  color: var(--tumblr-color);
}

.tumblr:focus-within {
  color: var(--tumblr-color);
}

.bluesky:hover {
  color: var(--bluesky-color);
}

.bluesky:focus-within {
  color: var(--bluesky-color);
}

.youtube:hover {
  color: var(--youtube-color);
}

.youtube:focus-within {
  color: var(--youtube-color);
}

.sketchfab:hover {
  color: var(--sketchfab-color);
}

.sketchfab:focus-within {
  color: var(--sketchfab-color);
}

.kofi:hover {
  color: var(--kofi-color);
}

.kofi:focus-within {
  color: var(--kofi-color);
}

.github:hover {
  color: var(--github-color);
}

.github:focus-within {
  color: var(--github-color);
}

/* Animations */

@keyframes fadein {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}

@keyframes fadein-top {
  from {
    transform: translateY(-2rem);
    opacity: 0;
  }
  to {
    transform: translateY(0rem);
    opacity: 1;
  }
}

@keyframes fadein-bottom {
  from {
    transform: translateY(2rem);
    opacity: 0;
  }
  to {
    transform: translateY(0rem);
    opacity: 1;
  }
}

@keyframes fadein-left {
  from {
    transform: translateX(-2rem);
    opacity: 0;
  }
  to {
    transform: translateX(0rem);
    opacity: 1;
  }
}

@keyframes fadein-right {
  from {
    transform: translateX(2rem);
    opacity: 0;
  }
  to {
    transform: translateX(0rem);
    opacity: 1;
  }
}

@keyframes grow {
  from {
    transform: scale(0);
  }
  to {
    transform: scale(1);
  }
}

@keyframes grow-top {
  from {
    transform: scaleY(0);
  }
  to {
    transform: scaleY(1);
  }
}

@keyframes grow-left {
  from {
    transform: scaleX(0);
  }
  to {
    transform: scaleX(1);
  }
}

/* Responsivity */

@media screen and (max-height: 630px) {
  body {
    flex-direction: row;
  }
  .footer-links-container {
    flex-direction: column;
  }
}

@media screen and (max-width: 520px) {
  body {
    flex-direction: column;
  }
  .footer-links-container {
    flex-direction: row;
  }
}

/* Languages */

:lang(kr) {
  word-break: keep-all;
  line-break: strict;
}

:lang(tc) {
  word-break: keep-all;
  line-break: strict;
}

/* Fonts */

.noto-sans-body {
  font-family: "Noto Sans", sans-serif;
  font-optical-sizing: auto;
  font-weight: 500;
  font-style: normal;
  font-variation-settings:
    "wdth" 100;
}

.noto-sans-kr-body {
  font-family: "Noto Sans KR", sans-serif;
  font-optical-sizing: auto;
  font-weight: 500;
  font-style: normal;
}

.noto-sans-tc-body {
  font-family: "Noto Sans TC", sans-serif;
  font-optical-sizing: auto;
  font-weight: 500;
  font-style: normal;
}

.noto-serif-body {
  font-family: "Noto Serif", serif;
  font-optical-sizing: auto;
  font-weight: 500;
  font-style: normal;
  font-variation-settings:
    "wdth" 100;
}

.noto-serif-kr-body {
  font-family: "Noto Serif KR", serif;
  font-optical-sizing: auto;
  font-weight: 500;
  font-style: normal;
}

.noto-serif-tc-body {
  font-family: "Noto Serif TC", serif;
  font-optical-sizing: auto;
  font-weight: 500;
  font-style: normal;
}

/* Typesetting */

.dropcap:first-letter {
  background: rgb(var(--text-rgb));
  color: rgb(var(--bg-rgb));
  float: left;
  font-family: "Noto Serif Display";
  font-size: 3.6rem;
  font-weight: 300;
  margin-right: 0.1em;
  padding: 0.25em;
}